# std::__debug::multimap< _Key, _Tp, _Compare, _Allocator > Class Template Reference

Class std::multimap with safety/checking/debug instrumentation. More...

Inheritance diagram for std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >:
[legend]

List of all members.

## Public Types

- typedef _Allocator allocator_type
- typedef
  __gnu_debug::_Safe_iterator
  < typename
  _Base::const_iterator,
  multimap > const_iterator
- typedef _Base::const_pointer const_pointer
- typedef _Base::const_reference const_reference
- typedef std::reverse_iterator
  < const_iterator > const_reverse_iterator
- typedef _Base::difference_type difference_type
- typedef
  __gnu_debug::_Safe_iterator
  < typename _Base::iterator,
  multimap > iterator
- typedef _Compare key_compare
- typedef _Key key_type
- typedef _Tp mapped_type
- typedef _Base::pointer pointer
- typedef _Base::reference reference
- typedef std::reverse_iterator
  < iterator > reverse_iterator
- typedef _Base::size_type size_type
- typedef std::pair< const _Key,
  _Tp > value_type

## Public Member Functions

- multimap (const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
- template<typename _InputIterator > multimap (_InputIterator __first, _InputIterator __last, const _Compare &__comp=_Compare(), const _Allocator &__a=_Allocator())
- multimap (const _Base &__x)
- multimap (multimap &&__x)
- multimap (const multimap &__x)
- multimap (initializer_list< value_type > __l, const _Compare &__c=_Compare(), const allocator_type &__a=allocator_type())
- _Base & _M_base ()
- const _Base & _M_base () const
- void _M_invalidate_all () const
- void _M_invalidate_if (_Predicate __pred)
- void _M_transfer_iter (const _Safe_iterator< _Iterator, multimap< _Key, _Tp, _Compare, _Allocator > > &__x)
- iterator begin ()
- const_iterator begin () const
- const_iterator cbegin () const
- const_iterator cend () const
- void clear ()
- const_reverse_iterator crbegin () const
- const_reverse_iterator crend () const
- iterator end ()
- const_iterator end () const
- std::pair< iterator, iterator > equal_range (const key_type &__x)
- std::pair< const_iterator,
  const_iterator > equal_range (const key_type &__x) const
- iterator erase (iterator __first, iterator __last)
- iterator erase (iterator __position)
- size_type erase (const key_type &__x)
- iterator find (const key_type &__x)
- const_iterator find (const key_type &__x) const
- void insert (std::initializer_list< value_type > __list)
- iterator insert (const value_type &__x)
- iterator insert (iterator __position, const value_type &__x)
- template<typename _InputIterator > void insert (_InputIterator __first, _InputIterator __last)
- iterator lower_bound (const key_type &__x)
- const_iterator lower_bound (const key_type &__x) const
- multimap & operator= (const multimap &__x)
- multimap & operator= (multimap &&__x)
- multimap & operator= (initializer_list< value_type > __l)
- const_reverse_iterator rbegin () const
- reverse_iterator rbegin ()
- const_reverse_iterator rend () const
- reverse_iterator rend ()
- void swap (multimap &__x)
- const_iterator upper_bound (const key_type &__x) const
- iterator upper_bound (const key_type &__x)

## Public Attributes

- _Safe_iterator_base * _M_const_iterators
- _Safe_iterator_base * _M_iterators
- unsigned int _M_version

## Protected Member Functions

- void _M_detach_all ()
- void _M_detach_singular ()
- __gnu_cxx::__mutex & _M_get_mutex () throw ()
- void _M_revalidate_singular ()
- void _M_swap (_Safe_sequence_base &__x)

## Detailed Description

### template<typename _Key, typename _Tp, typename _Compare = std::less<_Key>, typename _Allocator = std::allocator<std::pair<const _Key, _Tp> >>
class std::__debug::multimap< _Key, _Tp, _Compare, _Allocator >

Class std::multimap with safety/checking/debug instrumentation.

Definition at line 44 of file debug/multimap.h.

## Member Function Documentation

void __gnu_debug::_Safe_sequence_base::_M_detach_all | ( |  | ) | `[protected, inherited]`

Detach all iterators, leaving them singular.

void __gnu_debug::_Safe_sequence_base::_M_detach_singular | ( |  | ) | `[protected, inherited]`

Detach all singular iterators.

Postcondition:
  for all iterators i attached to this sequence, i->_M_version == _M_version.

__gnu_cxx::__mutex& __gnu_debug::_Safe_sequence_base::_M_get_mutex | ( |  | ) | throw ()`[protected, inherited]`

For use in _Safe_sequence.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

void __gnu_debug::_Safe_sequence_base::_M_invalidate_all | ( |  | ) | const`[inline, inherited]`

Invalidates all iterators.

Definition at line 215 of file safe_base.h.

void __gnu_debug::_Safe_sequence< multimap< _Key, _Tp, _Compare, _Allocator > >::_M_invalidate_if | ( | _Predicate | __pred | ) | `[inherited]`

Invalidates all iterators `x` that reference this sequence, are not singular, and for which `pred(x)` returns `true`. The user of this routine should be careful not to make copies of the iterators passed to `pred`, as the copies may interfere with the invalidation.

void __gnu_debug::_Safe_sequence_base::_M_revalidate_singular | ( |  | ) | `[protected, inherited]`

Revalidates all attached singular iterators. This method may be used to validate iterators that were invalidated before (but for some reason, such as an exception, need to become valid again).

void __gnu_debug::_Safe_sequence_base::_M_swap | ( | _Safe_sequence_base & | __x | ) | `[protected, inherited]`

Swap this sequence with the given sequence. This operation also swaps ownership of the iterators, so that when the operation is complete all iterators that originally referenced one container now reference the other container.

void __gnu_debug::_Safe_sequence< multimap< _Key, _Tp, _Compare, _Allocator > >::_M_transfer_iter | ( | const _Safe_iterator< _Iterator, multimap< _Key, _Tp, _Compare, _Allocator > > & | __x | ) | `[inherited]`

Transfers all iterators that reference this memory location to this sequence from whatever sequence they are attached to.

## Member Data Documentation

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_const_iterators `[inherited]`

The list of constant iterators that reference this container.

Definition at line 166 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

_Safe_iterator_base* __gnu_debug::_Safe_sequence_base::_M_iterators `[inherited]`

The list of mutable iterators that reference this container.

Definition at line 163 of file safe_base.h.

Referenced by __gnu_debug::_Safe_sequence< _Sequence >::_M_invalidate_if(), __gnu_debug::_Safe_iterator< _Iterator, _Sequence >::_M_invalidate_single(), and __gnu_debug::_Safe_sequence< _Sequence >::_M_transfer_iter().

unsigned int __gnu_debug::_Safe_sequence_base::_M_version `[mutable, inherited]`

The container version number. This number may never be 0.

Definition at line 169 of file safe_base.h.

The documentation for this class was generated from the following file:

- debug/multimap.h